jabberFu = AceLibrary("AceAddon-2.0"):new("AceDB-2.0", "AceHook-2.1", "FuBarPlugin-2.0")
jabberFu.hasIcon = "Interface\\GossipFrame\\PetitionGossipIcon"
jabberFu.cannotDetachTooltip = true
jabberFu.hasNoColor = true
local L = AceLibrary("AceLocale-2.2"):new("jabberFu")
L:RegisterTranslations("enUS", function() return({
	enabled = true,
		enabled_desc = "enable / disable",
}) end)
--
function jabberFu:OnInitialize()
	self.buttonHooks = {

	}
	self.stickyChannels = {
		"SAY",
		"YELL",
		"EMOTE",
		"PARTY",
		"RAID",
		"RAID_LEADER",
		"RAID_WARNING",
		"GUILD",
		"OFFICER",
		"WHISPER",
		"REPLY",
		"CHANNEL"
	}
	self.defaults = {
		editTop = true,
		replaceChat = {
			guild = "|cff339933[|rG|cff339933]|r%s|cff339933:|r",
			party = "|cff333399[|rP|cff333399]|r%s|cff333399:|r",
			raid = "|cff993333[|rR|cff993333]|r%s|cff993333:|r",
			say = "|cff666666[|rS|cff666666]|r%s|cff666666:|r",
			whisper = "|cff993333[|rW|cff993333]|r%s|cff993333:|r"
		},
		replaceChannel = {
			["%[(%d+)%. General%] "] = "|cff993399[|r%1.GN|cff993399]|r",
			["%[(%d+)%. LocalDefense%] "] = "|cff993399[|r%1.LD|cff993399]|r",
			["%[(%d+)%. Trade%] "] = "|cff993399[|r%1.TR|cff993399]|r",
			["%[(%d+)%. GuildRecruitment%] "] = "|cff993399[|r%1.GR|cff993399]|r"
		},
		scrollLines = 2,
		scrollEnd = IsModifierKeyDown,
		sticky = {},
		timestring = "|cff996633{|cffcc9933%H|cff996633:|cffcc9933%M|cff996633}|r"
	}
	self.options = {
		type = 'group', args={
			editTop={
				type="toggle", name="edit top", desc="edit top",
				get=function() return(self.db.profile.editTop) end,
				set=function(x) self.db.profile.editTop=x self:UpdateEditBox() end
			},
			replace={
				type="group", name="replace", desc="replace",
				args={
					chat={
						type="group", name="chat", desc="chat",
						args={
							guild={
								type="text", name="guild", desc="guild",
								get=function() return(self.db.profile.replaceChat.guild:gsub('|','||')) end,
								set=function(x) self.db.profile.replaceChat.guild=x:gsub('||','|') end,
								usage=""
							},
							party={
								type="text", name="party", desc="party",
								get=function() return(self.db.profile.replaceChat.party:gsub('|','||')) end,
								set=function(x) self.db.profile.replaceChat.party=x:gsub('||','|') end,
								usage=""
							},
							raid={
								type="text", name="raid", desc="raid",
								get=function() return(self.db.profile.replaceChat.raid:gsub('|','||')) end,
								set=function(x) self.db.profile.replaceChat.raid=x:gsub('||','|') end,
								usage=""
							},
							say={
								type="text", name="say", desc="say",
								get=function() return(self.db.profile.replaceChat.say:gsub('|','||')) end,
								set=function(x) self.db.profile.replaceChat.say=x:gsub('||','|') end,
								usage=""
							},
							whisper={
								type="text", name="whisper", desc="whisper",
								get=function() return(self.db.profile.replaceChat.whisper:gsub('|','||')) end,
								set=function(x) self.db.profile.replaceChat.whisper=x:gsub('||','|') end,
								usage=""
							}
						}
					},
					channel={
						type="group", name="channel", desc="channel",
						args={}
					}
				}
			},
			scrollLines={
				type="range", name="scroll lines", desc="scroll lines",
				min=1, max=6, step=1,
				get=function() return(self.db.profile.scrollLines) end,
				set=function(x) self.db.profile.scrollLines=x end
			},
			sticky = {
				type="group", name="sticky", desc="sticky",
				args={}
			},
			timestamp={
				type="text", name="timestamp", desc="timestamp",
				get=function() return(self.db.profile.timestring:gsub('|','||')) end,
				set=function(x) self.db.profile.timestring=x:gsub('||','|') end,
				usage="the time format string"
			}
		}
	}
	for k, v in pairs(self.stickyChannels) do
		self.defaults.sticky[v] = not ChatTypeInfo[v].sticky == 0
		self.options.args.sticky.args[v] = {
			type="toggle", order=k, name=v, desc=v,
			get=function() return(self.db.profile.sticky[v]) end,
			set=function(x)
				if(x) then
					ChatTypeInfo[v].sticky = 1
				else
					ChatTypeInfo[v].sticky = 0
				end
				self.db.profile.sticky[v] = x
			end
		}
	end
	self:RegisterDB("jabberFuDB")
	self:RegisterDefaults("profile", self.defaults)
	self.OnMenuRequest = self.options
end
--
function jabberFu:OnEnable()
	local p = self.db.profile
	ChatFrameMenuButton:Hide()
	for i = 1, 7 do
		local f = getglobal("ChatFrame"..i)
		f:EnableMouseWheel(true)
		f:SetScript("OnMouseWheel", function()
			if(arg1 > 0) then
				if(p:scrollEnd()) then
					this:ScrollToTop()
				else
					for i = 1, p.scrollLines do this:ScrollUp() end
				end
			else
				if(p:scrollEnd()) then
					this:ScrollToBottom()
				else
					for i = 1, p.scrollLines do this:ScrollDown() end
				end
			end
		end)
		local bb = getglobal("ChatFrame"..i.."BottomButton")
		for _, m in pairs({ "ScrollToBottom", "ScrollToTop", "ScrollDown", "ScrollUp", "PageDown", "PageUp" }) do
			f["jab"..m] = f[m]
			f[m] = function()
				f["jab"..m](f)
				if(f:AtBottom()) then
					bb:Hide()
				else
					bb:Show()
				end
			end
		end
		bb:ClearAllPoints()
		bb:SetPoint("BOTTOMRIGHT", f, 0, -4)
		bb:SetAlpha(0.8)
		bb:Hide()
		getglobal("ChatFrame"..i.."DownButton"):Hide()
		getglobal("ChatFrame"..i.."UpButton"):Hide()
	end
	self:UpdateChat()
	self:UpdateEditBox()
	self:Hook(DEFAULT_CHAT_FRAME, "AddMessage")
end
--
function jabberFu:UpdateChat()
	local p = self.db.profile
	local i = 1
	for k, _ in pairs(p.replaceChannel) do
		self.options.args.replace.args.channel.args[tostring(i)]={
			type="text", order=i, name=k, desc=k,
			get=function() return(p.replaceChannel[k]:gsub('|','||')) end,
			set=function(x) p.replaceChannel[k]=x:gsub('||','|') end,
			usage=""
		}
		i = i + 1
	end
	CHAT_GUILD_GET = p.replaceChat.guild
	CHAT_PARTY_GET = p.replaceChat.party
	CHAT_RAID_GET = p.replaceChat.raid
	CHAT_SAY_GET = p.replaceChat.say
	CHAT_WHISPER_GET = p.replaceChat.whisper
	for _, i in pairs(self.stickyChannels) do
		if(p.sticky[i]) then
			ChatTypeInfo[i].sticky = 1
		else
			ChatTypeInfo[i].sticky = 0
		end
	end
end
--
function jabberFu:UpdateEditBox()
	ChatFrameEditBox:ClearAllPoints()
	if(self.db.profile.editTop) then
		ChatFrameEditBox:SetPoint("BOTTOMLEFT",  ChatFrame1, "TOPLEFT",  -5, 2)
		ChatFrameEditBox:SetPoint("BOTTOMRIGHT",  ChatFrame1, "TOPRIGHT",  5, 2)
	else
		ChatFrameEditBox:SetPoint("TOPLEFT",  ChatFrame1, "BOTTOMLEFT",  -5, -2)
		ChatFrameEditBox:SetPoint("TOPRIGHT",  ChatFrame1, "BOTTOMRIGHT",  5, -2)
	end
end
--
function jabberFu:AddMessage(frame, text, r, g, b, id)
	if(text and text ~= "") then
		for k, v in pairs(self.db.profile.replaceChannel) do
			text = text:gsub(k, v)
		end
		text = date(self.db.profile.timestring)..text
		self.hooks[frame].AddMessage(frame, text, r, g, b, id)
	end
end